<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc (11.0.8) on Mon Nov 30 13:15:36 CET 2020 -->
<title>HardwareUtil</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-11-30">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
</head>
<body>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">org.eclipse.app4mc.amalthea.model.util</a></div>
<h2 title="Class HardwareUtil" class="title">Class HardwareUtil</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>Object</li>
<li>
<ul class="inheritance">
<li>HardwareUtil</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">HardwareUtil</span>
extends Object</pre>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>static Time</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#calculateHwAccessPathTime(org.eclipse.app4mc.amalthea.model.HwAccessElement,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.AccessDirection)">calculateHwAccessPathTime</a></span>&#8203;(HwAccessElement&nbsp;accessElement,
                         <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType,
                         <a href="RuntimeUtil.AccessDirection.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.AccessDirection</a>&nbsp;direction)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>static Long</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#calculateLatency(org.eclipse.app4mc.amalthea.model.IDiscreteValueDeviation,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">calculateLatency</a></span>&#8203;(IDiscreteValueDeviation&nbsp;latency,
                <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>static Time</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#calculateLatencyPathTime(org.eclipse.app4mc.amalthea.model.HwAccessElement,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.AccessDirection)">calculateLatencyPathTime</a></span>&#8203;(HwAccessElement&nbsp;accessElement,
                        <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType,
                        <a href="RuntimeUtil.AccessDirection.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.AccessDirection</a>&nbsp;direction)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>static List&lt;HwAccessElement&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getAccessElementsToDestination(org.eclipse.app4mc.amalthea.model.HwDestination,org.eclipse.app4mc.amalthea.model.Amalthea)">getAccessElementsToDestination</a></span>&#8203;(HwDestination&nbsp;dest,
                              Amalthea&nbsp;model)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>static Map&lt;ProcessingUnit,&#8203;HashMap&lt;HwDestination,&#8203;Time&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getAccessTimes(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.AccessDirection)">getAccessTimes</a></span>&#8203;(Amalthea&nbsp;model,
              <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType,
              <a href="RuntimeUtil.AccessDirection.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.AccessDirection</a>&nbsp;direction)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>static List&lt;ProcessingUnit&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getAllProcessingUnitsForProcessingUnitDefinition(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.ProcessingUnitDefinition)">getAllProcessingUnitsForProcessingUnitDefinition</a></span>&#8203;(Amalthea&nbsp;model,
                                                ProcessingUnitDefinition&nbsp;puDef)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>static Frequency</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getFrequencyOfModule(org.eclipse.app4mc.amalthea.model.HwModule)">getFrequencyOfModule</a></span>&#8203;(HwModule&nbsp;module)</code></th>
<td class="colLast">
<div class="block">Returns the frequency of a specific module</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>static long</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getFrequencyOfModuleInHz(org.eclipse.app4mc.amalthea.model.HwModule)">getFrequencyOfModuleInHz</a></span>&#8203;(HwModule&nbsp;module)</code></th>
<td class="colLast">
<div class="block">Returns the frequency of a specific module in Hertz</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>static Map&lt;Memory,&#8203;Long&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getMemoryAccessLatenciesCycles(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">getMemoryAccessLatenciesCycles</a></span>&#8203;(Amalthea&nbsp;model,
                              <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>static Map&lt;Memory,&#8203;Time&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getMemoryAccessLatencyTime(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">getMemoryAccessLatencyTime</a></span>&#8203;(Amalthea&nbsp;model,
                          <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>static DataRate</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getMinDataRateOfHwAccessPath(org.eclipse.app4mc.amalthea.model.HwAccessPath)">getMinDataRateOfHwAccessPath</a></span>&#8203;(HwAccessPath&nbsp;path)</code></th>
<td class="colLast">
<div class="block">Computes the minimum data rate of an access path</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>static &lt;T extends HwModule&gt;<br>List&lt;T&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getModulesFromHwModel(java.lang.Class,org.eclipse.app4mc.amalthea.model.Amalthea)">getModulesFromHwModel</a></span>&#8203;(Class&lt;T&gt;&nbsp;targetClass,
                     Amalthea&nbsp;model)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>static &lt;T extends HwModule&gt;<br>List&lt;T&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getModulesFromHWStructure(java.lang.Class,org.eclipse.app4mc.amalthea.model.HwStructure)">getModulesFromHWStructure</a></span>&#8203;(Class&lt;T&gt;&nbsp;targetClass,
                         HwStructure&nbsp;structure)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;Object</h3>
<code>equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="getModulesFromHwModel(java.lang.Class,org.eclipse.app4mc.amalthea.model.Amalthea)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getModulesFromHwModel</h4>
<pre class="methodSignature">public static&nbsp;&lt;T extends HwModule&gt;&nbsp;List&lt;T&gt;&nbsp;getModulesFromHwModel&#8203;(Class&lt;T&gt;&nbsp;targetClass,
                                                                 Amalthea&nbsp;model)</pre>
</li>
</ul>
<a id="getModulesFromHWStructure(java.lang.Class,org.eclipse.app4mc.amalthea.model.HwStructure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getModulesFromHWStructure</h4>
<pre class="methodSignature">public static&nbsp;&lt;T extends HwModule&gt;&nbsp;List&lt;T&gt;&nbsp;getModulesFromHWStructure&#8203;(Class&lt;T&gt;&nbsp;targetClass,
                                                                     HwStructure&nbsp;structure)</pre>
</li>
</ul>
<a id="getAllProcessingUnitsForProcessingUnitDefinition(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.ProcessingUnitDefinition)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getAllProcessingUnitsForProcessingUnitDefinition</h4>
<pre class="methodSignature">public static&nbsp;List&lt;ProcessingUnit&gt;&nbsp;getAllProcessingUnitsForProcessingUnitDefinition&#8203;(Amalthea&nbsp;model,
                                                                                    ProcessingUnitDefinition&nbsp;puDef)</pre>
</li>
</ul>
<a id="getMemoryAccessLatenciesCycles(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMemoryAccessLatenciesCycles</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;Memory,&#8203;Long&gt;&nbsp;getMemoryAccessLatenciesCycles&#8203;(Amalthea&nbsp;model,
                                                                    <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType)</pre>
</li>
</ul>
<a id="getMemoryAccessLatencyTime(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMemoryAccessLatencyTime</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;Memory,&#8203;Time&gt;&nbsp;getMemoryAccessLatencyTime&#8203;(Amalthea&nbsp;model,
                                                                <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType)</pre>
</li>
</ul>
<a id="getAccessElementsToDestination(org.eclipse.app4mc.amalthea.model.HwDestination,org.eclipse.app4mc.amalthea.model.Amalthea)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getAccessElementsToDestination</h4>
<pre class="methodSignature">public static&nbsp;List&lt;HwAccessElement&gt;&nbsp;getAccessElementsToDestination&#8203;(HwDestination&nbsp;dest,
                                                                   Amalthea&nbsp;model)</pre>
</li>
</ul>
<a id="getAccessTimes(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.AccessDirection)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getAccessTimes</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;ProcessingUnit,&#8203;HashMap&lt;HwDestination,&#8203;Time&gt;&gt;&nbsp;getAccessTimes&#8203;(Amalthea&nbsp;model,
                                                                                         <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType,
                                                                                         <a href="RuntimeUtil.AccessDirection.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.AccessDirection</a>&nbsp;direction)</pre>
</li>
</ul>
<a id="calculateLatencyPathTime(org.eclipse.app4mc.amalthea.model.HwAccessElement,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.AccessDirection)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>calculateLatencyPathTime</h4>
<pre class="methodSignature">public static&nbsp;Time&nbsp;calculateLatencyPathTime&#8203;(HwAccessElement&nbsp;accessElement,
                                            <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType,
                                            <a href="RuntimeUtil.AccessDirection.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.AccessDirection</a>&nbsp;direction)</pre>
</li>
</ul>
<a id="calculateHwAccessPathTime(org.eclipse.app4mc.amalthea.model.HwAccessElement,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.AccessDirection)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>calculateHwAccessPathTime</h4>
<pre class="methodSignature">public static&nbsp;Time&nbsp;calculateHwAccessPathTime&#8203;(HwAccessElement&nbsp;accessElement,
                                             <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType,
                                             <a href="RuntimeUtil.AccessDirection.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.AccessDirection</a>&nbsp;direction)</pre>
</li>
</ul>
<a id="calculateLatency(org.eclipse.app4mc.amalthea.model.IDiscreteValueDeviation,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>calculateLatency</h4>
<pre class="methodSignature">public static&nbsp;Long&nbsp;calculateLatency&#8203;(IDiscreteValueDeviation&nbsp;latency,
                                    <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;timeType)</pre>
</li>
</ul>
<a id="getMinDataRateOfHwAccessPath(org.eclipse.app4mc.amalthea.model.HwAccessPath)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMinDataRateOfHwAccessPath</h4>
<pre class="methodSignature">public static&nbsp;DataRate&nbsp;getMinDataRateOfHwAccessPath&#8203;(HwAccessPath&nbsp;path)</pre>
<div class="block">Computes the minimum data rate of an access path</div>
</li>
</ul>
<a id="getFrequencyOfModule(org.eclipse.app4mc.amalthea.model.HwModule)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFrequencyOfModule</h4>
<pre class="methodSignature">public static&nbsp;Frequency&nbsp;getFrequencyOfModule&#8203;(HwModule&nbsp;module)</pre>
<div class="block">Returns the frequency of a specific module</div>
</li>
</ul>
<a id="getFrequencyOfModuleInHz(org.eclipse.app4mc.amalthea.model.HwModule)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getFrequencyOfModuleInHz</h4>
<pre class="methodSignature">public static&nbsp;long&nbsp;getFrequencyOfModuleInHz&#8203;(HwModule&nbsp;module)</pre>
<div class="block">Returns the frequency of a specific module in Hertz</div>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
</body>
</html>
